#!/usr/bin/python
# -*- encoding: utf-8; py-indent-offset: 4 -*-
#
# Cisco EIGRP Peer metrics plugin
#
# Author: Th.L.
# Date  : 2017-12-26
#
# replaces :
#           local/share/check_mk/pnp-templates/check_mk-cisco_eigrp_peers.php
#           local/share/check_mk/web/plugins/perfometer/cisco_eigrp_peers.py
#
# missing a way to include hostname and service description
#

# key a       green      11/a       21/a       31/a       41/a       12/a       22/a       32/a       42/a
colors_a = ['#80F000', '#a500ff', '#ffc600', '#00ffb2', '#0075ff', '#cc00ff', '#ffd600', '#00ffff', '#0047ff',
            # 13/a       23/a       33/a       43/a       14/a       24/a       34/a       44/a       15/a
            '#f900ff', '#ffed00', '#00e8ff', '#000aff', '#ff4c00', '#e2ff00', '#00d1ff', '#4200ff', '#ff7a00',
            # 25/a       35/a       45/a       16/a       26/a       36/a       46/a       51/a       52/a
            '#bcff00', '#00b2ff', '#6000ff', '#ffa000', '#7fff00', '#0093ff', '#7f00ff', '#7f7f7f', '#7f4a26',
            # 53/a
            '#8c531c']
# key b       green      11/b       21/b       31/b       41/b       12/b       22/b       32/b       42/b
colors_b = ['#80F000', '#c966ff', '#cc9f00', '#00cc8e', '#66acff', '#e066ff', '#ccab00', '#00cccc', '#6690ff',
            # 13/b       23/b       33/b       43/b       14/b       24/b       34/b       44/b       15/b
            '#fb66ff', '#ccbd00', '#00b9cc', '#666cff', '#ff9366', '#b5cc00', '#00a7cc', '#8d66ff', '#ffaf66',
            # 25/b       35/b       45/b       16/b       26/b       36/b       46/b       51/b       52/b
            '#96cc00', '#008ecc', '#a066ff', '#ffc666', '#66cc00', '#0076cc', '#b266ff', '#7f7f7f', '#7f5f49',
            # 53/b
            '#8c6a48']


# def eigrp_render_uptime(uptime):  # expects time in seconds
#     m, s = divmod(uptime, 60)   # break in seconds / minutes
#     h, m = divmod(m, 60)        # break in mintes / hours
#     if h >= 24:                 # more then one day
#         d, h = divmod(h, 24)    # break in hours / days
#     else:
#         return '%02d:%02d:%02d' % (h, m, s)
#     if d >= 365:                # more the one year
#         y, d = divmod(d, 365)   # break in days / years
#         return '%dy %dd %02d:%02d:%02d' % (y, d, h, m, s)
#     else:
#         return '%dd %02d:%02d:%02d' % (d, h, m, s)


#####################################################################################################################
#
# define units for cisco_eigrp_* perfdata
#
#####################################################################################################################


# unit_info['uptime'] = {
#     'title': _('Uptime'),
#     'description': _('Timespan or Duration in seconds'),
#     'symbol': _('s'),
#     'render': lambda v: eigrp_render_uptime(v),
# }
unit_info['milliseconds'] = {
    'title': _('Milliseconds'),
    'symbol': 'ms',
    'render': lambda v: '%d' % v,
    'stepping': 'integer',  # for vertical graph labels
}


######################################################################################################################
#
# map eigrp perfdata to metric, not really necessary but makes sure to use the right metrics
#
######################################################################################################################


check_metrics['check_mk-cisco_eigrp_peers'] = {
    'cEigrpUpTime'      : {'name': 'cisco_eigrp_peers_cEigrpUpTime', },
    'cEigrpRetrans'     : {'name': 'cisco_eigrp_peers_cEigrpRetrans', },
    'cEigrpRetries'     : {'name': 'cisco_eigrp_peers_cEigrpRetries', },
    'cEigrpSrtt'        : {'name': 'cisco_eigrp_peers_cEigrpSrtt', },
    'cEigrpRto'         : {'name': 'cisco_eigrp_peers_cEigrpRto', },
    'cEigrpPktsEnqueued': {'name': 'cisco_eigrp_peers_cEigrpPktsEnqueued'}
}

check_metrics['check_mk-cisco_eigrp_interface'] = {
    'cEigrpPeerCount'      : {'name': 'cisco_eigrp_interface_cEigrpPeerCount', },
    'cEigrpXmitReliableQ'  : {'name': 'cisco_eigrp_interface_cEigrpXmitReliableQ', },
    'cEigrpXmitUnreliableQ': {'name': 'cisco_eigrp_interface_cEigrpXmitUnreliableQ', },
    'cEigrpMeanSrtt'       : {'name': 'cisco_eigrp_interface_cEigrpMeanSrtt', },
    'cEigrpPendingRoutes'  : {'name': 'cisco_eigrp_interface_cEigrpPendingRoutes', },
    'cEigrpRMcasts'        : {'name': 'cisco_eigrp_interface_cEigrpRMcasts', },
    'cEigrpUMcasts'        : {'name': 'cisco_eigrp_interface_cEigrpUMcasts', },
    'cEigrpUUcasts'        : {'name': 'cisco_eigrp_interface_cEigrpUUcasts', },
    'cEigrpRUcasts'        : {'name': 'cisco_eigrp_interface_cEigrpRUcasts', },
    'cEigrpMcastExcepts'   : {'name': 'cisco_eigrp_interface_cEigrpMcastExcepts', },
    'cEigrpCRpkts'         : {'name': 'cisco_eigrp_interface_cEigrpCRpkts', },
    'cEigrpAcksSuppressed' : {'name': 'cisco_eigrp_interface_cEigrpAcksSuppressed', },
    'cEigrpRetransSent'    : {'name': 'cisco_eigrp_interface_cEigrpRetransSent', },
    'cEigrpOOSrvcd'        : {'name': 'cisco_eigrp_interface_cEigrpOOSrvcd', },
}

check_metrics['check_mk-cisco_eigrp_topology_table'] = {
    'Internal'            : {'name': 'cisco_eigrp_topology_table_Internal', },
    'Connected'           : {'name': 'cisco_eigrp_topology_table_Connected', },
    'External'            : {'name': 'cisco_eigrp_topology_table_External', },
    'Summary'             : {'name': 'cisco_eigrp_topology_table_Summary', },
    'Static_redistributed': {'name': 'cisco_eigrp_topology_table_Static_redistributed', },
    'InetAddress'         : {'name': 'cisco_eigrp_topology_table_Inetaddress', },
    'activeroutes'        : {'name': 'cisco_eigrp_topology_table_activeroutes', },
    'siaroutes'           : {'name': 'cisco_eigrp_topology_table_siaroutes', },
    'routes'              : {'name': 'cisco_eigrp_topology_table_routes', },
}

check_metrics['check_mk-cisco_eigrp_as_info'] = {
    'cEigrpNbrCount'       : {'name': 'cisco_eigrp_as_info_cEigrpNbrCount', },
    'cEigrpHellosSent'     : {'name': 'cisco_eigrp_as_info_cEigrpHellosSent', },
    'cEigrpHellosRcvd'     : {'name': 'cisco_eigrp_as_info_cEigrpHellosRcvd', },
    'cEigrpUpdatesSent'    : {'name': 'cisco_eigrp_as_info_cEigrpUpdatesSent', },
    'cEigrpUpdatesRcvd'    : {'name': 'cisco_eigrp_as_info_cEigrpUpdatesRcvd', },
    'cEigrpQueriesSent'    : {'name': 'cisco_eigrp_as_info_cEigrpQueriesSent', },
    'cEigrpQueriesRcvd'    : {'name': 'cisco_eigrp_as_info_cEigrpQueriesRcvd', },
    'cEigrpRepliesSent'    : {'name': 'cisco_eigrp_as_info_cEigrpRepliesSent', },
    'cEigrpRepliesRcvd'    : {'name': 'cisco_eigrp_as_info_cEigrpRepliesRcvd', },
    'cEigrpAcksSent'       : {'name': 'cisco_eigrp_as_info_cEigrpAcksSent', },
    'cEigrpAcksRcvd'       : {'name': 'cisco_eigrp_as_info_cEigrpAcksRcvd', },
    'cEigrpInputQHighMark' : {'name': 'cisco_eigrp_as_info_cEigrpInputQHighMark', },
    'cEigrpInputQDrops'    : {'name': 'cisco_eigrp_as_info_cEigrpInputQDrops', },
    'cEigrpSiaQueriesSent' : {'name': 'cisco_eigrp_as_info_cEigrpSiaQueriesSent', },
    'cEigrpSiaQueriesRcvd' : {'name': 'cisco_eigrp_as_info_cEigrpSiaQueriesRcvd', },
    'cEigrpTopoRoutes'     : {'name': 'cisco_eigrp_as_info_cEigrpTopoRoutes', },
    'cEigrpXmitPendReplies': {'name': 'cisco_eigrp_as_info_cEigrpXmitPendReplies', },
}

#####################################################################################################################
#
# define metrics for eigrp peer perfdata
#
#####################################################################################################################

# define metrics for cisco_eigrp_peer perfdata

metric_info['cisco_eigrp_peers_cEigrpUpTime'] = {
    'title' : _('Peer uptime'),
    'unit'  : 's',
    'color' : colors_a[0],
}
metric_info['cisco_eigrp_peers_cEigrpPktsEnqueued'] = {
    'title' : _('Packets enqueued'),
    'unit'  : 'count',
    'color' : colors_a[1],
}
metric_info['cisco_eigrp_peers_cEigrpRetrans'] = {
    'title' : _('Retransmissions'),
    'unit'  : 'count',
    'color' : colors_a[2],
}
metric_info['cisco_eigrp_peers_cEigrpRetries'] = {
    'title' : _('Retries'),
    'unit'  : 'count',
    'color' : colors_a[3],
}
metric_info['cisco_eigrp_peers_cEigrpSrtt'] = {
    'title': _('Smooth round trip time'),
    'unit' : 'milliseconds',
    'color': colors_a[4],
}
metric_info['cisco_eigrp_peers_cEigrpRto'] = {
    'title' : _('Retransmission timeout'),
    'unit'  : 'milliseconds',
    'color' : colors_b[5],
}

# define metrics for cisco_eigrp_interface perfdata

metric_info['cisco_eigrp_interface_cEigrpPeerCount'] = {
    'title': _('Peer count'),
    'unit': 'count',
    'color': colors_a[0],
}
metric_info['cisco_eigrp_interface_cEigrpXmitReliableQ'] = {
    'title': _('Reliable queue length'),
    'unit': 'count',
    'color': colors_a[1],
}
metric_info['cisco_eigrp_interface_cEigrpXmitUnreliableQ'] = {
    'title': _('Unreliable queue length'),
    'unit': 'count',
    'color': colors_a[2],
}
metric_info['cisco_eigrp_interface_cEigrpMeanSrtt'] = {
    'title': _('Average smooth round trip time'),
    'unit': 'milliseconds',
    'color': colors_a[3],
}
metric_info['cisco_eigrp_interface_cEigrpPendingRoutes'] = {
    'title': _('Routing updates awaiting transmission'),
    'unit': 'count',
    'color': colors_a[4],
}
metric_info['cisco_eigrp_interface_cEigrpRMcasts'] = {
    'title': _('Reliable multicasts send'),
    'unit': 'count',
    'color': colors_a[5],
}
metric_info['cisco_eigrp_interface_cEigrpUMcasts'] = {
    'title': _('Unreliable multicasts send'),
    'unit': 'count',
    'color': colors_a[6],
}
metric_info['cisco_eigrp_interface_cEigrpUUcasts'] = {
    'title': _('Unreliable unicasts send'),
    'unit': 'count',
    'color': colors_a[7],
}
metric_info['cisco_eigrp_interface_cEigrpRUcasts'] = {
    'title': _('Reliable unicasts send'),
    'unit': 'count',
    'color': colors_a[8],
}
metric_info['cisco_eigrp_interface_cEigrpMcastExcepts'] = {
    'title': _('Multicast exceptions received'),
    'unit': 'count',
    'color': colors_a[9],
}
metric_info['cisco_eigrp_interface_cEigrpCRpkts'] = {
    'title': _('Conditional-Receive packets'),
    'unit': 'count',
    'color': colors_a[10],
}
metric_info['cisco_eigrp_interface_cEigrpAcksSuppressed'] = {
    'title': _('Suppressed acknowledgements'),
    'unit': 'count',
    'color': colors_a[11],
}
metric_info['cisco_eigrp_interface_cEigrpRetransSent'] = {
    'title': _('Retransmissions send'),
    'unit': 'count',
    'color': colors_a[12],
}
metric_info['cisco_eigrp_interface_cEigrpOOSrvcd'] = {
    'title': _('Out-of-sequence packets received'),
    'unit': 'count',
    'color': colors_a[13],
}

# define metrics for cisco_eigrp_topology_table perfdata

metric_info['cisco_eigrp_topology_table_routes'] = {
    'title': _('All routes'),
    'unit': 'count',
    'color': colors_a[0],
}
metric_info['cisco_eigrp_topology_table_activeroutes'] = {
    'title': _('Active routes'),
    'unit': 'count',
    'color': colors_a[1],
}
metric_info['cisco_eigrp_topology_table_siaroutes'] = {
    'title': _('Stuck in active (SIA) routes'),
    'unit': 'count',
    'color': colors_a[2],
}
metric_info['cisco_eigrp_topology_table_Connected'] = {
    'title': _('Connected'),
    'unit': 'count',
    'color': colors_a[3],
}
metric_info['cisco_eigrp_topology_table_Internal'] = {
    'title' : _('Internal'),
    'unit'  : 'count',
    'color' : colors_a[4],
}
metric_info['cisco_eigrp_topology_table_External'] = {
    'title': _('External'),
    'unit': 'count',
    'color': colors_a[5],
}
metric_info['cisco_eigrp_topology_table_Summary'] = {
    'title': _('Summary'),
    'unit': 'count',
    'color': colors_a[6],
}
metric_info['cisco_eigrp_topology_table_Static_redistributed'] = {
    'title' : _('Static redistributed'),
    'unit'  : 'count',
    'color' : colors_a[14],
}
metric_info['cisco_eigrp_topology_table_Inetaddress'] = {
    'title': _('Inet address'),
    'unit': 'count',
    'color': colors_a[17],
}

# define metrics for cisco_eigrp_as_info perfdata

metric_info['cisco_eigrp_as_info_cEigrpNbrCount'] = {
    'title': _('Neighbour count'),
    'unit': 'count',
    'color': colors_a[0],
}
metric_info['cisco_eigrp_as_info_cEigrpHellosSent'] = {
    'title': _('Hellos send'),
    'unit': '1/s',
    'color': colors_a[1],
}
metric_info['cisco_eigrp_as_info_cEigrpHellosRcvd'] = {
    'title': _('Hellos received'),
    'unit': '1/s',
    'color': colors_a[2],
}
metric_info['cisco_eigrp_as_info_cEigrpUpdatesSent'] = {
    'title': _('Updates send'),
    'unit': 'count',
    'color': colors_a[3],
}
metric_info['cisco_eigrp_as_info_cEigrpUpdatesRcvd'] = {
    'title': _('Updates received'),
    'unit': 'count',
    'color': colors_a[4],
}
metric_info['cisco_eigrp_as_info_cEigrpQueriesSent'] = {
    'title': _('Alternate route queries send'),
    'unit': 'count',
    'color': colors_a[5],
}
metric_info['cisco_eigrp_as_info_cEigrpQueriesRcvd'] = {
    'title': _('Alternate route queries received'),
    'unit': 'count',
    'color': colors_a[6],
}
metric_info['cisco_eigrp_as_info_cEigrpRepliesSent'] = {
    'title': _('Reply packets send'),
    'unit': 'count',
    'color': colors_a[7],
}
metric_info['cisco_eigrp_as_info_cEigrpRepliesRcvd'] = {
    'title': _('Reply packets received'),
    'unit': 'count',
    'color': colors_a[8],
}
metric_info['cisco_eigrp_as_info_cEigrpAcksSent'] = {
    'title': _('Acknowledgements send'),
    'unit': 'count',
    'color': colors_a[9],
}
metric_info['cisco_eigrp_as_info_cEigrpAcksRcvd'] = {
    'title': _('Acknowledgements received'),
    'unit': 'count',
    'color': colors_a[10],
}
metric_info['cisco_eigrp_as_info_cEigrpInputQHighMark'] = {
    'title': _('Highest number of packets in the input queue'),
    'unit': 'count',
    'color': colors_a[11],
}
metric_info['cisco_eigrp_as_info_cEigrpInputQDrops'] = {
    'title': _('Packets dropped from the input queue'),
    'unit': 'count',
    'color': colors_a[12],
}
metric_info['cisco_eigrp_as_info_cEigrpSiaQueriesSent'] = {
    'title': _('Stuck in active (SIA) queries sent'),
    'unit': 'count',
    'color': colors_a[13],
}
metric_info['cisco_eigrp_as_info_cEigrpSiaQueriesRcvd'] = {
    'title': _('Stuck in active (SIA) queries received'),
    'unit': 'count',
    'color': colors_a[14],
}
metric_info['cisco_eigrp_as_info_cEigrpTopoRoutes'] = {
    'title': _('Routes in the topology table'),
    'unit': 'count',
    'color': colors_a[15],
}
metric_info['cisco_eigrp_as_info_cEigrpXmitPendReplies'] = {
    'title': _('Outstanding replies expected to queries send'),
    'unit': 'count',
    'color': colors_a[16],
}

######################################################################################################################
#
# how to graph perdata for ciso_eigrp
#
######################################################################################################################

# graphs for cisco_eigrp_peer

graph_info.append({
    'title': _('Uptime'),
    'metrics': [
        ('cisco_eigrp_peers_cEigrpUpTime', 'area'),
    ],
})
graph_info.append({
    'title': _('Packets enqueued'),
    'metrics': [
        ('cisco_eigrp_peers_cEigrpPktsEnqueued', 'line'),
    ],
})
graph_info.append({
    'title': _('Smooth round trip time / retransmission timeout'),
    'metrics': [
        ('cisco_eigrp_peers_cEigrpSrtt', 'line'),
        ('cisco_eigrp_peers_cEigrpRto', 'line'),
    ],
})
graph_info.append({
    'title': _('Retransmissions / Retries'),
    'metrics': [
        ('cisco_eigrp_peers_cEigrpRetrans', 'line'),
        ('cisco_eigrp_peers_cEigrpRetries', 'line'),
    ],
})

# graphs for cisco_eigrp_as_info

graph_info.append({
    'title': _('Neighbour count'),
    'metrics': [
        ('cisco_eigrp_as_info_cEigrpNbrCount', 'line'),
    ],
})
graph_info.append({
    'title': _('Routes in the topology table'),
    'metrics': [
        ('cisco_eigrp_as_info_cEigrpTopoRoutes', 'line'),
    ],
})
graph_info.append({
    'title': _('Hellos send/received'),
    'metrics': [
        ('cisco_eigrp_as_info_cEigrpHellosSent', 'line'),
        ('cisco_eigrp_as_info_cEigrpHellosRcvd', '-line'),
    ],
})
graph_info.append({
    'title': _('Packets send/received'),
    'metrics': [
        ('cisco_eigrp_as_info_cEigrpQueriesSent', 'line'),
        ('cisco_eigrp_as_info_cEigrpUpdatesSent', 'line'),
        ('cisco_eigrp_as_info_cEigrpRepliesSent', 'line'),
        ('cisco_eigrp_as_info_cEigrpAcksSent', 'line'),
        ('cisco_eigrp_as_info_cEigrpSiaQueriesSent', 'line'),
        ('cisco_eigrp_as_info_cEigrpQueriesRcvd', '-line'),
        ('cisco_eigrp_as_info_cEigrpUpdatesRcvd', '-line'),
        ('cisco_eigrp_as_info_cEigrpRepliesRcvd', '-line'),
        ('cisco_eigrp_as_info_cEigrpAcksRcvd', '-line'),
        ('cisco_eigrp_as_info_cEigrpSiaQueriesRcvd', '-line'),
    ],
})
graph_info.append({
    'title': _('Input queue drops / Queue hi mark'),
    'metrics': [
        ('cisco_eigrp_as_info_cEigrpInputQDrops', 'line'),
        ('cisco_eigrp_as_info_cEigrpInputQHighMark', 'line'),
    ],
})

# graphs for cisco_eigrp_interface

graph_info.append({
    'title': _('Peer count'),
    'metrics': [
        ('cisco_eigrp_interface_cEigrpPeerCount', 'line'),
    ],
})
graph_info.append({
    'title': _('Queue length'),
    'metrics': [
        ('cisco_eigrp_interface_cEigrpXmitReliableQ', 'line'),
        ('cisco_eigrp_interface_cEigrpXmitUnreliableQ', 'line'),
    ],
})
graph_info.append({
    'title': _('Multicasts send'),
    'metrics': [
        ('cisco_eigrp_interface_cEigrpRMcasts', 'line'),
        ('cisco_eigrp_interface_cEigrpUMcasts', 'line'),
    ],
})
graph_info.append({
    'title': _('Unicasts send'),
    'metrics': [
        ('cisco_eigrp_interface_cEigrpUUcasts', 'line'),
        ('cisco_eigrp_interface_cEigrpRUcasts', 'line'),
    ],
})
graph_info.append({
    'title': _('Pending Routes'),
    'metrics': [
        ('cisco_eigrp_interface_cEigrpPendingRoutes', 'line'),
    ],
})
graph_info.append({
    'title': _('Various packets'),
    'metrics': [
        ('cisco_eigrp_interface_cEigrpMcastExcepts', 'line'),
        ('cisco_eigrp_interface_cEigrpCRpkts', 'line'),
        ('cisco_eigrp_interface_cEigrpRetransSent', 'line'),
        ('cisco_eigrp_interface_cEigrpOOSrvcd', 'line'),
    ],
})
graph_info.append({
    'title': _('Average smooth round trip time'),
    'metrics': [
        ('cisco_eigrp_interface_cEigrpMeanSrtt', 'line'),
    ],
})
graph_info.append({
    'title': _('Suppressed acknowledgements'),
    'metrics': [
        ('cisco_eigrp_interface_cEigrpAcksSuppressed', 'line'),
    ],
})

# define metrics for cisco_eigrp_topology_table perfdata

graph_info.append({
    'title': _('Routes by origin type'),
    'metrics': [
        ('cisco_eigrp_topology_table_Inetaddress', 'line'),
        ('cisco_eigrp_topology_table_Static_redistributed', 'line'),
        ('cisco_eigrp_topology_table_Summary', 'line'),
        ('cisco_eigrp_topology_table_External', 'line'),
        ('cisco_eigrp_topology_table_Internal', 'line'),
        ('cisco_eigrp_topology_table_Connected', 'line'),
        ('cisco_eigrp_topology_table_routes', 'line'),
    ],
    # 'range': (0, 'cisco_eigrp_topology_table_routes:max')
})

graph_info.append({
    'title': _('Stuck in active (SIA) / active routes'),
    'metrics': [
        ('cisco_eigrp_topology_table_siaroutes', 'line'),
        ('cisco_eigrp_topology_table_activeroutes', 'line'),
    ],
})


######################################################################################################################
#
# define perf-o-meter for cisco_eigrp
#
######################################################################################################################

# cisco_eigrp_peers peer uptime
perfometer_info.append({
    'type': 'logarithmic',
    'metric': 'cisco_eigrp_peers_cEigrpUpTime',
    'half_value': 2592000.0,
    'exponent': 2,
})

# cisco_eigrp_interface send packets
perfometer_info.append({
        'type': 'linear',
        'segments': ['cisco_eigrp_interface_cEigrpPeerCount'],
        'total': 50,
    })

# cisco_eigrp_topology_table
perfometer_info.append({
        'type': 'linear',
        'segments': ['cisco_eigrp_topology_table_routes'],
        'total': 1000,
    })

# cisco_eigrp_as_info
perfometer_info.append({
    'type': 'linear',
    'segments': ['cisco_eigrp_as_info_cEigrpNbrCount'],
    'total': 30,
})
