#!/usr/bin/python
# -*- encoding: utf-8; py-indent-offset: 4 -*-

#
# Check_MK cisco_eigrp_peer WATO plugin
#
# Author: Th.L.
# Date: 2017-12-27
#
#
#
#

ignore_interfaces_auth = [
    (6, 'Ethernet CSMAD'),
    (24, 'Loopback'),
    (53, 'Proprietary Virtual (Cisco VLAN L3)'),
    (131, 'Tunnel'),
    (135, 'Layer 2 VLAN',),
    (136, 'Layer 3 IP VLAN'),
]

register_check_parameters(
    subgroup_networking,
    'cisco_eigrp_interface',
    _('Cisco EIGRP interface'),
    Dictionary(
        help=_(''),
        elements=[
            ('ignore_interfaces_auth',
             ListChoice(
                 title=_('no warning if EIRGP authentication not configured on selected interface types'),
                 label=_('no warning if EIRGP authentication not configured on selected interface types'),
                 help=_('no warning if EIRGP authentication not configured on selected interface types'),
                 choices=ignore_interfaces_auth,
                 default_value=[],
             )),
            ('no_auth_state',
             MonitoringState(
                 title=_('State to report when interface has no authentication configured'),
                 help=_(
                     'State if an EIGRP enabled interface has no authentication configured. Default is critical'),
                 default_value=2,
             ),
             ),

            ('md5_auth_state',
             MonitoringState(
                 title=_('State to report when interface uses MD5 authentication'),
                 help=_('State if an EIGRP enabled interface uses an MD5 hash as authentication method. Default is warning'),
                 default_value=1,
             ),
             ),
        ],
    ),
    TextAscii(title=_('Cisco EIGRP interface')),
    match_type='dict',
)
