#!/usr/bin/python
# -*- encoding: utf-8; py-indent-offset: 4 -*-

#
# Check_MK cisco_eigrp_peer WATO plugin
#
# Author: Th.L.
# Date: 2017-12-25
#
#
#
#
register_check_parameters(
    subgroup_networking,
    'cisco_eigrp_peers',
    _('Cisco EIGRP peer'),
    Dictionary(
        help=_(''),
        elements=[
            ('minuptime',
             Integer(
                 help=_('Set the time in seconds, a peer must be up before the peer is considered sable.'
                        'If the peer uptime less then X, the check outcome is set to warning.'),
                 title=_('Minimum uptime for peer. If uptime less, set check outcome to warning. Default is 1 day.'),
                 default_value=86400,
                 allow_empty=False,
                 unit='seconds',
                 minvalue=1,
             ),
             )
        ],
    ),
    TextAscii(title=_('Cisco EIGRP peer')),
    match_type='dict',
)